from bot.botbase import BotBase
from protocol.protocols import ProtocolHandshake, ProtocolAuth, ProtocolSpawn, ProtocolState
from settings import Settings_auth, Settings_spawn
from asyncio import AbstractEventLoop
from consts import STATES as ST
from typesdata.v754 import UUID


class BotAuth(BotBase):
    settings: Settings_auth
    uuid: UUID

    def __init__(self, settings: Settings_auth, loop: AbstractEventLoop = None):
        super(BotAuth, self).__init__(settings, loop)

        self.profile = settings.profile
        self.name = settings.profile.display_name
        self.logger.name += f':{self.name}'
    
    def set_start(self):
        self.add_protocol(ST.HANDSHAKING)(ProtocolHandshake)
        self.add_protocol(ST.STATUS)(ProtocolState)
        self.add_protocol(ST.LOGIN)(ProtocolAuth)

import logging
class BotSpawn(BotAuth):
    default_loglevel = logging.DEBUG
    def __init__(self, settings: Settings_spawn, loop: AbstractEventLoop = None):
        super(BotSpawn, self).__init__(settings, loop)
        self.position_look: list[float] = [0.0, 0.0, 0.0, 0.0, 0.0]

    def set_start(self):
        super(BotSpawn, self).set_start()
        self.add_protocol(ST.PLAY)(ProtocolSpawn)
