import minecraft_data
from typesdata import get_types


class Mcd:
    data: dict
    protocol_version: int
    version: str

    __cach_dict: dict[str, list[dict]] = {}

    def __init__(self, version: str) -> None:
        if not isinstance(version, str):
            raise TypeError(f'"version" of type {type(version).__name__}')
        
        self.__cached_data = self._getmcd(version)

        self.version = version
        self.data = self.__cached_data[0]
        self.protocol_version = self.data['version']['version']
        self.types = get_types(self.protocol_version)

    @classmethod
    def _getmcd(cls, version: str) -> list[dict]:
        mcd = cls.__cach_dict.get(version)
        if mcd is None:
            mcd = [minecraft_data(version), 1]
            cls.__cach_dict[version] = mcd
        mcd[1] += 1
        return mcd

    def __del__(self):
        try:
            nums = self.__cached_data[1] - 1
            if nums <= 0:
                del self.__class__.__cach_dict[self.version]

        except IndexError:
            pass