from cryptography.hazmat.primitives.asymmetric.rsa import RSAPublicKey
from dataclasses import dataclass


@dataclass
class OfflineProfile:
    display_name: str = "quarry"
    online: bool = False

    def __hash__(self) -> int:
        return object.__hash__(self)


@dataclass
class OnlineProfile:
    display_name: str = "quarry"
    online: bool = True

    def __hash__(self) -> int:
        return object.__hash__(self)
    

@dataclass
class PlayerPublicKey:
    expiry: int
    key: RSAPublicKey
    signature: bytes
    
