from router.baserouter import BaseRouter, BaseStorage, Callback, BaseHeandler, CallbackUnheandler
from mcd.packets import Coder


class PacketRouter(BaseRouter):
    pass


class PacketStorage(BaseStorage):
    _storage: tuple[set[Callback]]

    def __init__(self, event_encoder: Coder):
        self.event_encoder = event_encoder
        self._storage = tuple(set() for _ in range(len(self.event_encoder.encoder)))

    def set(self, event_id, callback):
        return super().set(self.event_encoder.encoder[event_id], callback)


class PacketHeandler(BaseHeandler):
    target_router = PacketRouter
