from bot4.net.auth import OfflineProfile, OnlineProfile
from typing import Union
from dataclasses import dataclass
from bot4.consts import DISPLAYED_SKIN_PARTS, MAIN_HAND, CHAT_MODE, RESOURCE_PACK_STATUS


@dataclass
class ClientSettings:
    locale: str
    view_distance: int
    chat_mode: int
    chat_colors: bool
    displayed_skin_parts: int
    main_hand: int

    def __hash__(self) -> int:
        return object.__hash__(self)


@dataclass
class Settings:
    version: str = '1.16.5'
    ip: str = 'mc.prostocraft.ru'
    port: int = 25565
    clientsettings: ClientSettings = ClientSettings('ru_ru', 1, CHAT_MODE.ENABLED, True, DISPLAYED_SKIN_PARTS.CAPE, MAIN_HAND.RIGHT)
    custom_payload: bytes = b'\x0fminecraft:brand\x06fabric'
    resource_pack_status: int = RESOURCE_PACK_STATUS.DECLINED

    def __hash__(self) -> int:
        return object.__hash__(self)

@dataclass
class Settings_auth(Settings):
    profile: Union[OfflineProfile, OnlineProfile] = OfflineProfile()

    def __hash__(self) -> int:
        return object.__hash__(self)

Settings_spawn = Settings_auth

